//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Rec.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)

TRec *Rec;
//---------------------------------------------------------------------------

Byte *FrameBuf;
DWORD  *BufUsed;
int  FrameSize;

Graphics::TBitmap *Pic;
TMemoryStream  *BufferArea;
Byte *ptr;
bool       DelayFlag,SaveFlag,Ready;
int        FrameCount,DelayCount;
int        TriggerLevel,Ahead,Behind;
LRESULT CALLBACK capWaveStreamCallback(HWND hWnd,LPWAVEHDR lpWHdr);
LRESULT CALLBACK capVideoStreamCallback(HWND hWnd,LPVIDEOHDR lpVHdr);
LRESULT CALLBACK capYieldCallback(HWND hWnd);
//---------------------------------------------------------------------------
__fastcall TRec::TRec(HWND HWnd)
{
  Handle=HWnd;
  Live=false;
  Pic = new Graphics::TBitmap();
  Pic->Height=240;
  Pic->Width=320;
  BufferArea= new TMemoryStream();

}

__fastcall TRec::~TRec()
{
//  AVIFileExit();
}


void __fastcall TRec::SetVideoFormat(void)
{
  //]wv榡 ----{b
  CAPTUREPARMS Capture;
  capCaptureGetSetup(Video,&Capture,sizeof(CAPTUREPARMS));
  Capture.fAbortRightMouse=false;
  Capture.fAbortLeftMouse=false;
  Capture.dwRequestMicroSecPerFrame = 33334; //30 frame Per Sec
  Capture.dwAudioBufferSize = 356; //900301
  capCaptureSetSetup(Video,&Capture,sizeof(CAPTUREPARMS));
}

void __fastcall TRec::ShowLive(void)
{
if(!Live)
 {
  Video = capCreateCaptureWindow("Capture Window",
                               WS_CHILD|WS_VISIBLE,
                               0,0,320,240, 
                               Handle,
                               0); //1
  capDriverConnect(Video,0);
  if(!capOverlay(Video,true))
  {
    // capPreviewRate(Video, 100);  PreviewMode!!
     capPreview(Video,true);
  }
  UpdateWindow(Video);
  Live = true;
  SetVideoFormat();
 }
}

void __fastcall TRec::StopShowLive(void)
{
  if(Live)
  {
    capDriverDisconnect(Video);
    DestroyWindow(Video);
    Live = false;
    Video = NULL; //900426
  }
}

void __fastcall TRec::Record()
{
  if(capSetCallbackOnYield(Video,capYieldCallback)&&capSetCallbackOnVideoStream(Video,capVideoStreamCallback))
  {
      //can handel Message while record
      capCaptureSequenceNoFile(Video); //Capture
  }
}

void __fastcall TRec::StopRecord()
{
  capCaptureStop(Video);
}
void __fastcall TRec::Stop()
{
  capCaptureStop(Video);
  capCaptureAbort(Video);
}



bool __fastcall TRec::Overlay(bool Flag)
{
  capOverlay(Video,!Flag);
  if(!capOverlay(Video,Flag))
    capPreview(Video,Flag);
  return(true);
}

bool __fastcall TRec::DlgVideoFormat(void)
{
  return capDlgVideoFormat(Video);
}

bool __fastcall TRec::DlgVideoSource(void)
{
  return capDlgVideoSource(Video);
}

bool __fastcall TRec::DlgVideoDisplay(void)
{
  return capDlgVideoDisplay(Video);
}

HWND __fastcall TRec::Get_A_Frame()
{
  int x_cnt,y_cnt,cnt;
  Byte red,blue,green,*ptr;

  if(FrameBuf!=0)
  {

    BufferArea->Write(FrameBuf,FrameSize);
    cnt=0;
    BufferArea->Position=0;
    for( x_cnt=Pic->Height-1;x_cnt>=0;x_cnt--)
    {
      for( y_cnt=0;y_cnt<Pic->Width;y_cnt++)
      {
        BufferArea->Read(&blue,1);
        BufferArea->Read(&green,1);
        BufferArea->Read(&red,1);
        Pic->Canvas->Pixels[y_cnt][x_cnt]=RGB(red,green,blue);
      //  cnt+=3;
      }
    }

   BufferArea->Clear();
  }
  return(Pic->Canvas->Handle);

}
//****************YieldCallback******************************
LRESULT CALLBACK capYieldCallback(HWND hWnd)
{//can handel Message while record

////////////////////////////////////////////////////////////////////////
//  hWnd:           Application main window handle
////////////////////////////////////////////////////////////////////////
 MSG msg;

    if (PeekMessage(&msg,NULL,0,0,PM_REMOVE)) {
        TranslateMessage(&msg);
        DispatchMessage(&msg);
    }

    // Return TRUE to continue capturing
    return (LRESULT) TRUE;
}
LRESULT CALLBACK capVideoStreamCallback(HWND hWnd,LPVIDEOHDR lpVHdr)
{
 int cnt;


  if(FrameBuf==0)
  {
     FrameSize=lpVHdr->dwBufferLength;
     FrameBuf=new Byte[FrameSize];
     BufUsed=new DWORD;
     BufferArea->SetSize(FrameSize);

  }

  *BufUsed = lpVHdr->dwBytesUsed;
  for( cnt=0;cnt<FrameSize;cnt++)
  {
    FrameBuf[cnt]=lpVHdr->lpData[cnt];
  }
  return (LRESULT) TRUE ;
}




